---
title: Config Options for ada
sidebar_label: ada
---

| Option | Description | Values | Default |
| ------ | ----------- | ------ | ------- |
|sortParamsByRequiredFlag|Sort method arguments to place required parameters before optional parameters.| |true|
|sortModelPropertiesByRequiredFlag|Sort model properties to place required parameters before optional parameters.| |true|
|ensureUniqueParams|Whether to ensure parameter names are unique in an operation (rename parameters that are not).| |true|
|allowUnicodeIdentifiers|boolean, toggles whether unicode identifiers are allowed in names or not, default is false| |false|
|prependFormOrBodyParameters|Add form or body parameters to the beginning of the parameter list.| |false|
|projectName|GNAT project name| |defaultProject|

## IMPORT MAPPING

| Type/Alias | Imports |
| ---------- | ------- |


## INSTANTIATION TYPES

| Type/Alias | Instantiated By |
| ---------- | --------------- |


## LANGUAGE PRIMITIVES

<ul data-columns="2" style="list-style-type: disc;-webkit-columns:2;-moz-columns:2;columns:2;-moz-column-fill:auto;column-fill:auto"><li>Integer</li>
<li>boolean</li>
<li>Character</li>
<li>double</li>
<li>integer</li>
<li>Boolean</li>
<li>float</li>
<li>long</li>
</ul>

## RESERVED WORDS

<ul data-columns="2" style="list-style-type: disc;-webkit-columns:2;-moz-columns:2;columns:2;-moz-column-fill:auto;column-fill:auto"><li>exception</li>
<li>synchronized</li>
<li>constant</li>
<li>mod</li>
<li>select</li>
<li>declare</li>
<li>separate</li>
<li>use</li>
<li>do</li>
<li>elsif</li>
<li>body</li>
<li>type</li>
<li>while</li>
<li>when</li>
<li>aliased</li>
<li>protected</li>
<li>tagged</li>
<li>else</li>
<li>loop</li>
<li>function</li>
<li>record</li>
<li>raise</li>
<li>rem</li>
<li>if</li>
<li>case</li>
<li>others</li>
<li>all</li>
<li>new</li>
<li>package</li>
<li>in</li>
<li>is</li>
<li>then</li>
<li>pragma</li>
<li>accept</li>
<li>entry</li>
<li>exit</li>
<li>at</li>
<li>delay</li>
<li>task</li>
<li>null</li>
<li>abort</li>
<li>overriding</li>
<li>terminate</li>
<li>begin</li>
<li>some</li>
<li>private</li>
<li>access</li>
<li>for</li>
<li>range</li>
<li>interface</li>
<li>out</li>
<li>not</li>
<li>goto</li>
<li>array</li>
<li>subtype</li>
<li>and</li>
<li>of</li>
<li>end</li>
<li>xor</li>
<li>or</li>
<li>limited</li>
<li>abstract</li>
<li>procedure</li>
<li>reverse</li>
<li>generic</li>
<li>renames</li>
<li>requeue</li>
<li>with</li>
<li>abs</li>
<li>digits</li>
<li>until</li>
<li>return</li>
</ul>
