---
title: Config Options for eiffel
sidebar_label: eiffel
---

| Option | Description | Values | Default |
| ------ | ----------- | ------ | ------- |
|packageName|Eiffel Cluster name (convention: lowercase).| |openapi|
|packageVersion|Eiffel package version.| |1.0.0|
|hideGenerationTimestamp|Hides the generation timestamp when files are generated.| |true|

## IMPORT MAPPING

| Type/Alias | Imports |
| ---------- | ------- |
|LocalDateTime|org.joda.time.*|
|Set|java.util.*|
|LocalTime|org.joda.time.*|
|HashMap|java.util.HashMap|
|ArrayList|java.util.ArrayList|
|URI|java.net.URI|
|Timestamp|java.sql.Timestamp|
|LocalDate|org.joda.time.*|
|BigDecimal|java.math.BigDecimal|
|Date|java.util.Date|
|DateTime|org.joda.time.*|
|Array|java.util.List|
|List|java.util.*|
|UUID|java.util.UUID|
|File|java.io.File|
|Map|java.util.Map|


## INSTANTIATION TYPES

| Type/Alias | Instantiated By |
| ---------- | --------------- |
|array|ARRAYED_LIST|
|list|ARRAYED_LIST|
|map|STRING_TABLE|


## LANGUAGE PRIMITIVES

<ul data-columns="2" style="list-style-type: disc;-webkit-columns:2;-moz-columns:2;columns:2;-moz-column-fill:auto;column-fill:auto"><li>INTEGER_16</li>
<li>NATURAL_16</li>
<li>INTEGER_8</li>
<li>REAL_32</li>
<li>INTEGER_32</li>
<li>INTEGER_64</li>
<li>REAL_64</li>
<li>NATURAL_8</li>
<li>BOOLEAN</li>
<li>NATURAL_64</li>
<li>NATURAL_32</li>
</ul>

## RESERVED WORDS

<ul data-columns="2" style="list-style-type: disc;-webkit-columns:2;-moz-columns:2;columns:2;-moz-column-fill:auto;column-fill:auto"><li>agent</li>
<li>select</li>
<li>separate</li>
<li>convert</li>
<li>do</li>
<li>when</li>
<li>else</li>
<li>loop</li>
<li>elseif</li>
<li>only</li>
<li>precursor</li>
<li>variant</li>
<li>create</li>
<li>from</li>
<li>export</li>
<li>if</li>
<li>all</li>
<li>ensure</li>
<li>void</li>
<li>like</li>
<li>old</li>
<li>frozen</li>
<li>require</li>
<li>check</li>
<li>then</li>
<li>undefine</li>
<li>invariant</li>
<li>as</li>
<li>external</li>
<li>once</li>
<li>inspect</li>
<li>true</li>
<li>deferred</li>
<li>note</li>
<li>obsolete</li>
<li>local</li>
<li>result</li>
<li>across</li>
<li>redefine</li>
<li>tuple</li>
<li>current</li>
<li>expanded</li>
<li>not</li>
<li>feature</li>
<li>and</li>
<li>alias</li>
<li>end</li>
<li>xor</li>
<li>attribute</li>
<li>class</li>
<li>rescue</li>
<li>retry</li>
<li>debug</li>
<li>or</li>
<li>false</li>
<li>rename</li>
<li>inherit</li>
<li>until</li>
<li>implies</li>
<li>assign</li>
</ul>
