---
title: Config Options for mysql-schema
sidebar_label: mysql-schema
---

| Option | Description | Values | Default |
| ------ | ----------- | ------ | ------- |
|defaultDatabaseName|Default database name for all MySQL queries| ||
|jsonDataTypeEnabled|Use special JSON MySQL data type for complex model properties. Requires MySQL version 5.7.8. Generates TEXT data type when disabled| |true|
|identifierNamingConvention|Naming convention of MySQL identifiers(table names and column names). This is not related to database name which is defined by defaultDatabaseName option|<dl><dt>**original**</dt><dd>Do not transform original names</dd><dt>**snake_case**</dt><dd>Use snake_case names</dd><dl>|original|

## IMPORT MAPPING

| Type/Alias | Imports |
| ---------- | ------- |


## INSTANTIATION TYPES

| Type/Alias | Instantiated By |
| ---------- | --------------- |


## LANGUAGE PRIMITIVES

<ul data-columns="2" style="list-style-type: disc;-webkit-columns:2;-moz-columns:2;columns:2;-moz-column-fill:auto;column-fill:auto"><li>date</li>
<li>void</li>
<li>bool</li>
<li>string</li>
<li>double</li>
<li>byte</li>
<li>mixed</li>
<li>integer</li>
<li>float</li>
<li>URI</li>
<li>int</li>
<li>Date</li>
<li>DateTime</li>
<li>long</li>
<li>BigDecimal</li>
<li>number</li>
<li>boolean</li>
<li>file</li>
<li>binary</li>
<li>char</li>
<li>short</li>
<li>ByteArray</li>
<li>UUID</li>
</ul>

## RESERVED WORDS

<ul data-columns="2" style="list-style-type: disc;-webkit-columns:2;-moz-columns:2;columns:2;-moz-column-fill:auto;column-fill:auto"><li>dec</li>
<li>low_priority</li>
<li>references</li>
<li>leading</li>
<li>insensitive</li>
<li>ssl</li>
<li>character</li>
<li>int2</li>
<li>int1</li>
<li>io_after_gtids</li>
<li>trailing</li>
<li>int4</li>
<li>int3</li>
<li>utc_time</li>
<li>int8</li>
<li>optimizer_costs</li>
<li>rank</li>
<li>cube</li>
<li>databases</li>
<li>using</li>
<li>outer</li>
<li>require</li>
<li>then</li>
<li>each</li>
<li>as</li>
<li>left</li>
<li>unique</li>
<li>except</li>
<li>starting</li>
<li>schema</li>
<li>accessible</li>
<li>role</li>
<li>deterministic</li>
<li>long</li>
<li>into</li>
<li>smallint</li>
<li>default</li>
<li>dual</li>
<li>partition</li>
<li>varying</li>
<li>by</li>
<li>ntile</li>
<li>where</li>
<li>xor</li>
<li>persist</li>
<li>current_time</li>
<li>key</li>
<li>iterate</li>
<li>set</li>
<li>column</li>
<li>minute_microsecond</li>
<li>procedure</li>
<li>right</li>
<li>union</li>
<li>asc</li>
<li>call</li>
<li>varbinary</li>
<li>longblob</li>
<li>describe</li>
<li>to</li>
<li>localtime</li>
<li>sql_big_result</li>
<li>declare</li>
<li>empty</li>
<li>enclosed</li>
<li>div</li>
<li>generated</li>
<li>continue</li>
<li>leave</li>
<li>loop</li>
<li>elseif</li>
<li>hour_second</li>
<li>row_number</li>
<li>signal</li>
<li>add</li>
<li>percent_rank</li>
<li>unlock</li>
<li>last_value</li>
<li>mediumtext</li>
<li>check</li>
<li>escaped</li>
<li>collate</li>
<li>schemas</li>
<li>persist_only</li>
<li>decimal</li>
<li>desc</li>
<li>cursor</li>
<li>drop</li>
<li>virtual</li>
<li>asensitive</li>
<li>for</li>
<li>show</li>
<li>revoke</li>
<li>update</li>
<li>purge</li>
<li>not</li>
<li>undo</li>
<li>zerofill</li>
<li>json_table</li>
<li>load</li>
<li>straight_join</li>
<li>ignore</li>
<li>lines</li>
<li>over</li>
<li>mediumint</li>
<li>varchar</li>
<li>false</li>
<li>dense_rank</li>
<li>mediumblob</li>
<li>with</li>
<li>window</li>
<li>grant</li>
<li>day_second</li>
<li>explain</li>
<li>maxvalue</li>
<li>mod</li>
<li>select</li>
<li>release</li>
<li>usage</li>
<li>optionally</li>
<li>middleint</li>
<li>delayed</li>
<li>convert</li>
<li>localtimestamp</li>
<li>sql_small_result</li>
<li>when</li>
<li>cume_dist</li>
<li>else</li>
<li>lock</li>
<li>join</li>
<li>spatial</li>
<li>if</li>
<li>write</li>
<li>between</li>
<li>case</li>
<li>sqlstate</li>
<li>order</li>
<li>year_month</li>
<li>read_write</li>
<li>having</li>
<li>natural</li>
<li>in</li>
<li>double</li>
<li>tinytext</li>
<li>index</li>
<li>tinyint</li>
<li>is</li>
<li>sensitive</li>
<li>grouping</li>
<li>exit</li>
<li>current_date</li>
<li>system</li>
<li>analyze</li>
<li>binary</li>
<li>sqlwarning</li>
<li>force</li>
<li>interval</li>
<li>master_bind</li>
<li>minute_second</li>
<li>primary</li>
<li>regexp</li>
<li>range</li>
<li>sqlexception</li>
<li>infile</li>
<li>restrict</li>
<li>recursive</li>
<li>foreign</li>
<li>hour_microsecond</li>
<li>out</li>
<li>distinctrow</li>
<li>get</li>
<li>fulltext</li>
<li>table</li>
<li>current_user</li>
<li>linear</li>
<li>second_microsecond</li>
<li>change</li>
<li>utc_timestamp</li>
<li>float8</li>
<li>io_before_gtids</li>
<li>trigger</li>
<li>float4</li>
<li>kill</li>
<li>lead</li>
<li>day_minute</li>
<li>rlike</li>
<li>rename</li>
<li>hour_minute</li>
<li>fetch</li>
<li>stored</li>
<li>char</li>
<li>exists</li>
<li>constraint</li>
<li>high_priority</li>
<li>return</li>
<li>no_write_to_binlog</li>
<li>sql_calc_found_rows</li>
<li>before</li>
<li>use</li>
<li>precision</li>
<li>modifies</li>
<li>replace</li>
<li>integer</li>
<li>float</li>
<li>while</li>
<li>lag</li>
<li>optimize</li>
<li>nth_value</li>
<li>function</li>
<li>limit</li>
<li>varcharacter</li>
<li>create</li>
<li>from</li>
<li>tinyblob</li>
<li>alter</li>
<li>group</li>
<li>all</li>
<li>read</li>
<li>like</li>
<li>cascade</li>
<li>real</li>
<li>inner</li>
<li>separator</li>
<li>both</li>
<li>day_microsecond</li>
<li>condition</li>
<li>blob</li>
<li>null</li>
<li>true</li>
<li>day_hour</li>
<li>option</li>
<li>longtext</li>
<li>keys</li>
<li>outfile</li>
<li>values</li>
<li>distinct</li>
<li>insert</li>
<li>numeric</li>
<li>resignal</li>
<li>delete</li>
<li>sql</li>
<li>database</li>
<li>master_ssl_verify_server_cert</li>
<li>and</li>
<li>current_timestamp</li>
<li>of</li>
<li>repeat</li>
<li>first_value</li>
<li>row</li>
<li>bigint</li>
<li>terminated</li>
<li>on</li>
<li>or</li>
<li>cross</li>
<li>match</li>
<li>reads</li>
<li>groups</li>
<li>rows</li>
<li>specific</li>
<li>int</li>
<li>inout</li>
<li>unsigned</li>
<li>utc_date</li>
</ul>
